;-------------------------------------------------------------------------------
; assegnata in dati.asm POSIZIONE
; posizione iniziale
start_pos      equ "rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1"
; Liv             Mosse               Nodi
;  1                 20                 20
;  2                400                420
;  3              8.902              9.322
;  4            197.281            206.603
;  5          4.865.609          5.072.212
;  6        119.060.324        124.132.536
;  7      3.195.901.860      3.320.034.396
;  8     84.998.978.956     88.319.013.352
;  9  2.439.530.234.167  2.527.849.247.519
; 10 69.352.859.712.417 71.880.708.959.936

start_posx		 equ "rnbqkbnr/pppppppp/8/8/8/4P3/PPPP1PPP/RNBQKBNR w KQkq - 0 1"
; Liv             Mosse		ms freccia    ms crafty
;  1                 30       1              0
;  2                593       1              0
;  3             18.327       1              0
;  4            397.196      21             50
;  5         12.642.325     625           1350
;  6        302.144.054   14977          37350

test_pos1      equ "r1bqk2r/pppp1ppp/2n2n2/2b1p3/2B1P3/2N2N2/PPPP1PPP/R1BQK2R w KQkq - 0 5"
; Liv             Mosse		ms freccia    ms crafty
;  1               36         1              0
;  2             1256					1							 0
;  3            43408					3							 0
;  4          1492118        81            180
;  5         51781599      2539           5870
;  6       1785363392     85729         220310

; 1: perft=36 ms=1 nodi=1 n/s=1000 mosse=36 m/s=36000
; 2: perft=1256 ms=1 nodi=37 n/s=37000 mosse=1292 m/s=1292000
; 3: perft=43408 ms=3 nodi=1293 n/s=431000 mosse=44700 m/s=14900000
; 4: perft=1492118 ms=76 nodi=44701 n/s=588171 mosse=1536818 m/s=20221289
; 5: perft=51781599 ms=2586 nodi=1536819 n/s=594284 mosse=53318417 m/s=20618104
; 6: perft=1785363392 ms=84076 nodi=53318418 n/s=634169 mosse=1838681809 m/s=21869283

test_enp       equ "k7/6p1/8/5P1P/2p1p3/8/3P4/K7 w - - 0 1"
; Liv             Mosse		ms freccia    ms crafty
;  1                7         1              0
;  2               55         1              0
;  3              458         1              0
;  4             3974         1              0
;  5            34462         3              0
;  6           323384        26             40
;  7          2889524       232            370
;  8         28209635      2158           3370
test_enp_n     equ "7k/8/8/8/3Pp3/8/8/7K b - d3 0 1"
test_enp_b     equ "8/8/8/3Pp3/8/8/8/K6k w - e6 0 1"
; perft 2 19
test_mate      equ "3qk3/8/8/8/8/8/PPPPPPPP/RNBQKBNR w - - 0 1"
test_mate2		 equ "1k6/6R1/1K6/8/8/8/8/8 w - - 0 14"
; perft: 19 34

duere_pos       equ "8/8/4k3/8/8/3K4/8/8 w - - 0 1"
;-------------------------------------------------------------------------------
test_perft0    equ "8/8/3k4/8/3K4/8/8/8 w - - 0 1"
; Liv         Mosse          Nodi
; 1               5             5
; 2
;-------------------------------------------------------------------------------
test_perft1    equ "8/2p5/3p4/KP5r/1R3p1k/8/4P1P1/8 w - -"
; Liv         Mosse    ms freccia   ms crafty
; 1              14          1
; 2             191          1
; 3           2.812          1
; 4          43.238          4
; 5         674.624         43
; 6      11.030.083        726
; 7     178.633.661      10397        21830
;-------------------------------------------------------------------------------
test_promo1		 equ "8/1P6/8/8/8/8/8/K6k w - - 0 1"
; Liv         Mosse
; 1              7
; 2             19
; 3            227
; 4          1.221
; 5         18.835
; 6         90.183
; 7      1.634.115
;-------------------------------------------------------------------------------
m_donna				 equ "8/8/8/3Q4/8/8/8/8 w - - 0 1"
;-------------------------------------------------------------------------------
test_pos2      equ "8/3k4/8/8/8/3p4/3K4/8 w - - 0 1"
test_pos3      equ "p2p2p1/8/8/p2Q3p/8/8/p7/3p3p b - - 0 1"
test_pos4      equ "1rb2rk1/p1q1bppp/1pnpp3/2pnP3/3P4/2P2NP1/PP1N1PBP/R1BQR1K1 w - - 0 12"
; Liv         Mosse          Nodi
; 1            31
; 2         1.146
; 3        38.387
; 4     1.442.721
; 5    51.245.074
; 6
; 7

test_scacco1   equ "8/4q3/6K1/8/6k1/8/8/8 w - - 0 1"

test_matto_1   equ "8/8/8/8/8/1K1R4/8/1k6 w - - 0 1"
test_matto_2   equ "8/8/8/8/8/1KR5/8/1k6 w - - 0 1"
test_matto_3   equ "8/8/8/8/1R6/1K6/8/k7 w - - 0 1"
test_matto_4a  equ "8/8/8/8/1K6/8/7Q/3k4 w - - 0 1"
test_matto_4b  equ "1k6/1P1p1p1p/1K6/8/8/8/P2P1P1P/8 w - - 0 1"
test_matto_4c  equ "4n3/2p4R/2P2p1P/5P1p/3P3P/5pBB/8/5K1k w - - 0 1"
test_matto_4d  equ "4n3/2p2R2/2P2p2/5P1p/3P3P/5pBB/8/5K1k w - - 0 1"
test_matto     equ "6b1/1p6/6p1/8/1p5p/8/8/BB3K1k w - - 0 1"
test_m7				 equ "7R/n1p1pBk1/2r2pP1/1qN5/3rP1PP/4p1Kb/1Bn5/bQ6 w - - 0 1"
test_m3        equ "k7/8/BK6/8/8/1N6/8/8 w - - 0 1"

xxx            equ "8/2p5/2P2p2/5P1p/3Pn2P/5pBB/8/4RK1k w - - 0 1"
tm_1           equ "8/8/8/8/6Q1/8/3p1ppk/3Kbrrb w - - 0 1"
tm_1_n         equ "8/8/8/6Q1/8/7k/3p1pp1/3Kbrrb b - - 0 1"
tm_2					 equ "8/8/6Q1/8/8/7k/3p1pp1/3Kbrrb w - - 0 1"
tm_4           equ "6Q1/8/8/7k/8/8/3p1pp1/3Kbrrb w - - 0 1"
final_001      equ "8/7R/2rk1p2/4bR2/1p1pK3/6P1/1P5P/8 w - - 0 49" ; Txe5

epd_000        equ "5rk1/1p6/q2P3p/2p2rp1/p1nbQ3/P1N3BP/1PR1B1P1/4K3 b - - bm Rf1+; id '1.5.IQ.918';"
epd_001				 equ "4r1k1/1pq2p1p/2p2npb/2N5/1PPQn1P1/7P/6B1/B2R2K1 b - - bm Ng3; id '2.5.IQ.921';"
epd_002				 equ "2q1r2k/5R1p/pp1B2pN/2p1P3/1n1b4/3P2Q1/1P4K1/8 w - - bm Qh4; id '3.5.IQ.931';"
epd_003				 equ "6rk/7p/Q2R1p2/1p2n3/4b3/1P4NP/P1P2PPK/2q5 b - - bm Qf1; id '4.5.IQ.934';"
epd_004        equ "2k1r2r/ppn3pq/b7/5p2/5Qn1/2N1B1P1/1P3PB1/2RR2K1 w - - bm Qxc7+; id '5.5.IQ.936';"
epd_005        equ "2k4r/pp3ppp/2p2n2/5PBb/P3P3/2Nr3P/1PB2bP1/R3R2K b - - bm Rxh3+; id '6.5.IQ.1009';"
epd_006        equ "r5k1/pq2pn2/3pN1pp/n2P4/1rp1PQ2/1P3PP1/PN4K1/2R4R w - - bm Rxh6 Nd3; id '7.5.IQ.1010';"

mate_6_001     equ "r3nrk1/p1qp1b1p/6pp/2b3P1/1QP2P2/2BP2P1/P1N2N2/1K3R2 w - - 0 1"
good_move      equ "1r1q1rk1/pb3p2/1p4pB/3pPn2/1bpR4/2N1P3/PPQ2PP1/1B2K2R w K - 0 1"
test_speed_01  equ "2R2b1r/3nkp2/B2pp1p1/1N4Pn/P3P3/4BP2/1r5q/3QK1R1 w - -"
									; crafty: 7"32" ply 12 Nd4
									; arasan: 465"  ply 12 Nd4
test_speed_02  equ "2q3k1/1p4pp/3p1b2/pb1Pp3/r5P1/1P1nQN1P/P2N1P2/R1B3K1 b - - 0 1"
									; Rebel 12: 1'!

;-------------------------------------------------------------------------------
testnow1 equ "1n6/1P5p/7P/8/8/8/8/k6K w - - 0 1" ; perft:  3 18 144 1260 12115 109480 1365043 12680341
testnow2 equ "1n6/1P6/8/8/8/8/8/k6K w - - 0 1"   ; perft:  3 18 144 1260 12115 110169 1382813 12843910
testnow3 equ "8/1P6/8/8/8/8/8/k6K w - - 0 1"     ; perft:  7 17 179  910 11792  56498  852257  4485918
testnow4 equ "8/8/8/8/8/1Q6/8/k6K w - - 0 1"     ; perft: 26 39 948 3738 94223 361562 9248432 40054822
testnow5 equ "8/8/8/8/8/1R6/8/k6K w - - 0 1"     ; perft:                                     12295269
testnow6 equ "8/8/8/8/8/2N5/8/k6K w - - 0 1"     ; perft:                                      3663674
testnow7 equ "8/7P/8/8/8/8/8/k6K w - - 0 1"      ; perft:  7 19 219
testarr1 equ "rnbqk2r/pppp1ppp/5n2/2b1p3/2B1P3/5N2/PPPP1PPP/RNBQK2R w KQkq - 0 4"
testarr2 equ "r3k2r/pppp1ppp/8/4p3/4P3/8/PPPP1PPP/R3K2R w KQkq - 0 1"
testarr3 equ "r3k2r/pppp1ppp/8/4p3/4P3/8/PPPP1PPP/R3K2R w KQ - 0 1"
testarr4 equ "r3k2r/pppp1ppp/8/4p3/4P3/8/PPPP1PPP/R3K2R w kq - 0 1"
testarr5 equ "r3k2r/pppp1ppp/8/4p3/4P3/8/PPPP1PPP/R3K2R w Kk - 0 1"
testarr6 equ "r3k2r/pppp1ppp/8/4p3/4P3/8/PPPP1PPP/R3K2R w K - 0 1"
testarr7 equ "r3k2r/pppp1ppp/8/4p3/4P3/8/PPPP1PPP/R3K2R w Q - 0 1"
testarr8 equ "r3k2r/pppp1ppp/8/4p3/4P3/8/PPPP1PPP/R3K2R w - - 0 1"

