.586
.model flat,STDCALL
.code
;-------------------------------------------------------------------------------
Tttt proc
	test eax, [ebx]
  nop
  test ax, [ebx]
  nop
	test eax, [ebx]
  nop
  test ax, [ebx]
  nop
  ret
endp
;-------------------------------------------------------------------------------
Esegui1 proc
  xchg [edi.cFlags], eax     						; eax=flags pezzo preso o casa vuota
  mov [ebx.pCasa], edi       						; aggiorna la casa del pezzo
  xchg [edi.cPezzo], ebx     						; ebx=pezzo preso
  mov [edx.mFlags], eax      						; salva i flags per annullare la mossa
  mov [edx.mPreso], ebx      						; salva il pezzo preso per annullare la mossa
  and eax, F_VALORE											; toglie il flag di segno
  mov [edx.mDst], edi        						; salva la casa di destinazione per annullare la mossa
	add _ret_vals.rValPos, eax	 					; aggiorna il valore della posizione
 	cmp [esi.nCasaEnP], 0									; casa della presa enpassant
  je em_test_arrocco

	ret
endp
Esegui2 proc
  mov eax, F_VALORE
	movq mm0, [edi]
  movq mm1, [ecx]
  movq [edi], mm1
  movq [edx], mm0
  and eax, [edx.mFlags]
  mov [edx.mDst], edi        						; salva la casa di destinazione per annullare la mossa
	add _ret_vals.rValPos, eax	 					; aggiorna il valore della posizione
 	cmp [esi.nCasaEnP], 0									; casa della presa enpassant
  je em_test_arrocco
	ret
endp
;-------------------------------------------------------------------------------

PUSHM_1 proc
	; eax: flags colore
  ; edi: mossa
	; ebp: valore progressivo della posizione
	; ecx: pezzo
	; edx: casa
	; -> edi+=size Mossa
	; -> ebx: valore della mossa
	; NB: NON DEVE CAMBIARE I FLAGS!!!
  mov ebx, [edx+delta]                  ; cFlags
  mov [edi.mDelta], delta								; spostamento
  mov [edi.mPezzo], ecx    							; pezzo
  mov [edi.mValore], ebx   							; valore
  if DEBUG_ASSERT
    mov [edi.mSrc], edx									; salva la casa sorgente
  endif
  lea edi, [edi+size Mossa]             ; punta alla prossima mossa
  ret
endp
;-------------------------------------------------------------------------------
PUSHM_2 proc
	; eax: flags colore
  ; edi: mossa
	; ebp: valore progressivo della posizione
	; ecx: pezzo
	; edx: casa
	; -> edi+=size Mossa
	; -> ebx: valore della mossa
	; NB: NON DEVE CAMBIARE I FLAGS!!!
  movq mm0, [edx+delta]                 ; cFlags/Valore+cPezzo
  mov [edi.mDelta], delta								; spostamento
    mov [edx.mPromoFlags], 0              ; segnala che non si tratta una promozione
  movq [edi], mm0         							; cFlags+cPezzo
  if DEBUG_ASSERT
    mov [edi.mSrc], edx									; salva la casa sorgente
  endif
  lea edi, [edi+size Mossa]             ; punta alla prossima mossa
  ret
endp
;-------------------------------------------------------------------------------
EseguiMossa proc
	; esi: nodo
	; edx: mossa da eseguire
	if DEBUG_ASSERT
  	cmp [esi.nEseAnn], 0
    je em_okassert
    call DebugVariante
    ret
em_okassert:
		inc [esi.nEseAnn]
  endif

  if DEBUG_ALFAGEMMA
  	ACAPO
  	ACAPO
	  PUTCHAR '+'
  	call DebugMossa
  endif
  if 1
    cmp [esi.nLivello], 0
    jne em_notick
    PUTCHAR '^'
  endif
em_notick:
	mov [edx.mValore], MINIMO
	mov [esi.nEseguita], edx   						; salva la mossa eseguita
	mov ebx, [edx.mPezzo]      						; ebx=pezzo
	mov eax, VUOTA           							; casa vuota
	mov edi, [ebx.pCasa]       						; edi=casa sorgente
	mov ecx, [edx.mDelta]      						; ecx=delta
	mov [esi.nEnPassant], 0    						; casa non valida per enpassant
	mov [esi.nCasaEnP], 0									; casa della presa enpassant
	mov [edx.mSrc], edi        						; salva la casa sorgente per annullare la mossa
  inc [ebx.pNumMosse]										; numero di mosse eseguite dal pezzo
	mov [edi.cPezzo], 0        						; DEBUG: NON INDISPENSABILE
	xchg [edi.cFlags], eax     						; cancella il pezzo e carica i flags
	add edi, [edx.mDelta]      						; edi=casa destinazione
	;--------------------------- test spinta di due di pedone
	test eax, F_PEDONE
	je em_nopedone
	cmp ecx, [esi.nDelta2]     						; verifica se si tratta di una spinta di due
	jne em_nodidue
	mov [esi.nEnPassant], edi  						; posizione pedone prendibile enpassant
  jmp em_nopedone
em_nodidue:
	cmp edi, offset promoN
  jge em_promozione
	cmp edi, offset promoB
  jge em_nopromo
em_promozione:
  push eax
	mov eax, [edx.mPromoGen]              ; carica la nuova routine generazione mosse del pedone promosso
  xchg [ebx.pMuovi], eax								; aggiorna il pezzo
	mov [edx.mPromoGen], eax              ; salva la vecchia routine generazione mosse del pedone promosso
  pop eax
	xchg eax, [edx.mPromoFlags]						; carica i nuovi flags del pedone promosso e salva quelli del pedone
  jmp em_muovi													; NB: la mossa non  sicuramente un enpassant, essendo una promozione
em_nopromo:
	cmp ecx, E
  je em_enpassant                       ; l'enpassant viene salvato come presa laterale
	cmp ecx, W
  jne em_nopedone
em_enpassant:
	mov [esi.nCasaEnP], edi								; casa della presa enpassant
em_nopedone:
  mov [edx.mPromoFlags], 0              ; segnala che non si tratta una promozione
em_muovi:
  xchg [edi.cFlags], eax     						; eax=flags pezzo preso o casa vuota
  mov [ebx.pCasa], edi       						; aggiorna la casa del pezzo
  xchg [edi.cPezzo], ebx     						; ebx=pezzo preso
  mov [edx.mFlags], eax      						; salva i flags per annullare la mossa
  mov [edx.mPreso], ebx      						; salva il pezzo preso per annullare la mossa
  and eax, F_VALORE											; toglie il flag di segno
  mov [edx.mDst], edi        						; salva la casa di destinazione per annullare la mossa
	add _ret_vals.rValPos, eax	 					; aggiorna il valore della posizione
 	cmp [esi.nCasaEnP], 0									; casa della presa enpassant
  je em_test_arrocco
em_aggiusta_enpassant:
	; eax: flags pedone preso
  ; ebx: pedone preso
  ; edi: casa destinazione fittizia (=casa del pedone preso)
  ; edx: mossa
  push eax
  push ecx
  mov ecx, edi
  add ecx, [esi.nDelta1]            		; casa destinazione reale
  mov eax, [ecx.cFlags]									; sposta il pedone mosso
  xchg [edi.cFlags], eax                ; nella casa di presa en-passant
  mov [ecx.cFlags], eax
  mov eax, [ecx.cPezzo]
  xchg [edi.cPezzo], eax
  mov ebx, eax                          ; pedone mosso
  mov [ecx.cPezzo], eax
  mov [edx.mDst], ecx                   ; aggiorna la casa di destinazione del pedone che prende nella mossa
  mov [ebx.pCasa], ecx                  ; aggiorna la casa di destinazione del pedone che prende nei dati del pezzo
  pop ecx
  pop eax
  jmp em_ret
em_test_arrocco:
	cmp [edx.mTorre], 0                   ; TODO: possibile baco: non viene azzerato se le mosse non vengono giocate perch il nodo viene tagliato
  je em_ret                             ;       identificare l'arrocco in un modo pi sicuro
em_arrocco:
	push ebx
	push ecx
  mov ecx, [edx.mDelta]									; somma met del delta per trovare la casa della torre
  sar ecx, 1
	add ecx, [edx.mSrc]
  mov ebx, [edx.mTorre]
  mov ebx, [ebx.pCasa]									; casa sorgente della torre
  mov eax, VUOTA
  mov [edx.mSrcTorre], ebx							; salva la casa sorgente della torre per AnnullaMossa
  xchg eax, [ebx.cFlags]
  mov [ecx.cFlags], eax
  xor eax, eax
  xchg eax, [ebx.cPezzo]								; toglie la torre
  mov [ecx.cPezzo], eax									; la sposta (eax = torre)
  mov [edx.mDstTorre], ecx							; salva la casa destinazione della torre per AnnullaMossa
  mov [eax.pCasa], ecx 									; aggiorna la posizione della torre
  pop ebx
  pop ecx
em_ret:
	if DEBUG_ALFAGEMMA
	  call DebugCase
  endif
	ret
endp
;-------------------------------------------------------------------------------
; macro MUOVI con presa
MUOVIP proc
	mov ebx, src.cPezzo                   ; ebx = pezzo da muovere
	mov eax, src.cFlags                   ; eax = flags
  mov [ebx.cPezzo], VUOTA								; cancella il pezzo dalla casa
  mov [ebx.pCasa], dst                  ; aggiorna la posizione del pezzo
  xchg eax, dst.cFlags                  ; scambia i flags del pezzo mosso con quelli del pezzo preso
  xchg ebx, dst.cPezzo                  ; scambia il pezzo mosso con quello preso, nella casa destinazione
  mov [edi.mFlagsPreso], eax            ; salva i flags del pezzo preso per annullare la mossa
  mov [ebx.pCasa], 0                    ; annulla il pezzo preso
  ret
endp
;-------------------------------------------------------------------------------
; macro MUOVI su casa vuota
MUOVIV proc
	mov ebx, src.cPezzo                   ; ebx = pezzo da muovere
	mov eax, src.cFlags                   ; eax = flags
  mov [ebx.cPezzo], VUOTA								; cancella il pezzo dalla casa
  mov [ebx.pCasa], dst                  ; aggiorna la posizione del pezzo
  mov dst.cFlags, eax                   ; sposta i flags
  mov dst.cPezzo, ebx                   ; sposta il pezzo
  ret
endp
;-------------------------------------------------------------------------------
; mosse di Re e Cavallo (seconda versione)
;-------------------------------------------------------------------------------
; and bit colore      z: preso pezzo ---\___legale
;                     s: vuota       ---/
;                     g: illegale
FAST_NODIR proc
	local @tnd_fine
	; eax: flags colore
	; ebp: valore progressivo della posizione
	; ecx: pezzo
	; edx: casa
	test dst.cFlags, flags
	jg @tnd_fine
@tnd_fine:
	ret
endp
;-------------------------------------------------------------------------------
Dummy PROC
  FAST_NODIR scacchiera, scacchiera, 1
	ret
endp
;-------------------------------------------------------------------------------
end

